module Container.Container where 

-- * Imports

-- ** Stdlib

open import Function

open import Data.Empty
open import Data.Unit
open import Data.Product
open import Data.Sum

-- ** Local

open import Pow

-- * Definition

-- Containers are objects of the category O → Fam(Fam(I))

infixl 60 _▸_
record _▸_ (I O : Set) : Set1 where
  field
    S : O → Set
    P : {o : O} → S o → Set
    n : {o : O}{sh : S o} → P sh → I
open _▸_ public


-- * Extension of a container

⟦_⟧ : {I O : Set} → I ▸ O → Pow I → Pow O
⟦ φ ⟧ X o = Σ[ sh ∶ S φ o ] ((p : P φ sh) → X (n φ p))


⟦_⟧Morph : {I O : Set}{X Y : I → Set} → (φ : I ▸ O) → 
           (f : X ⟶ Y) → ⟦ φ ⟧ X ⟶ ⟦ φ ⟧ Y
⟦ φ ⟧Morph f (sh , pos) = (sh , f ∘ pos)

-- * Outro

-- Local Variables:
-- mode: outline-minor
-- outline-regexp: "-- [*\f]+"
-- outline-level: outline-level
-- End:                      
