module Main where

-- * Library

import Pow
import IProp

-- * Containers

import Container.Container
import Container.Fixpoint
import Container.Initiality
import Container.Morphism
import Container.CartesianMorphism

-- * Ornament

import Ornament.Ornament
import Ornament.OrnamentalAlgebra

import Ornament.AlgebraicOrnament

import Ornament.CoalgebraicOrnament

import Ornament.PullbackOrnament

-- * Lifting

import Lifting.Universe
import Lifting.Patch
import Lifting.Lifter

-- * Example

import Example.Container
import Example.Ornament
import Example.AlgebraicOrnament
import Example.Lifting

-- * Outro

-- Local Variables:
-- mode: outline-minor
-- outline-regexp: "-- [*\f]+"
-- outline-level: outline-level
-- End:                      
